aboutsummaryrefslogtreecommitdiffstats
path: root/recipes/udev/udev-151/udev-compat-static.patch
blob: 22f1b99fe538b903866d405ae79e728397f4935e (plain)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
--- /dev/null
+++ b/recipes/udev/udev-151/init
@@ -0,0 +1,91 @@
+#!/bin/sh -e
+
+### BEGIN INIT INFO
+# Provides:          udev
+# Required-Start:    mountvirtfs
+# Required-Stop:
+# Default-Start:     S
+# Default-Stop:
+# Short-Description: Start udevd, populate /dev and load drivers.
+### END INIT INFO
+
+export TZ=/etc/localtime
+
+KERNELMICROVER="$(uname -r | awk -F. '{print $3}')"
+
+DAEMON="/sbin/udevd"
+UDEVADM="/sbin/udevadm"
+
+# If we are running an old kernel and have a static udev present use that instead
+if [ -e /sbin/udevd-124-static ] ; then
+       if [ $KERNELMICROVER -lt 27 ] ; then
+           DAEMON="/sbin/udevd-124-static"
+               UDEVADM="/sbin/udevadm-124-static"
+       fi
+fi
+
+[ -d /sys/class ] || exit 1
+[ -r /proc/mounts ] || exit 1
+[ -x $DAEMON ] || exit 1
+[ -f /etc/default/udev ] && . /etc/default/udev
+[ -f /etc/udev/udev.conf ] && . /etc/udev/udev.conf
+
+kill_udevd() {
+        if [ -x /sbin/pidof ]; then
+                pid=`/sbin/pidof -x udevd`
+                [ -n "$pid" ] && kill $pid
+        fi
+}
+
+export ACTION=add
+# propagate /dev from /sys
+echo "Starting udev"
+
+# mount the tmpfs on /dev, if not already done
+LANG=C awk "\$2 == \"/dev\" && \$4 == \"tmpfs\" { exit 1 }" /proc/mounts && {
+        mount -n -o mode=0755 -t tmpfs none "/dev"
+        mkdir -m 0755 /dev/pts
+        mkdir -m 1777 /dev/shm
+}
+
+if [ "$DEVCACHE" != "" ]; then
+       # Invalidate udev cache if the kernel or its bootargs/cmdline have changed
+       [ -x /bin/uname ] && /bin/uname -mrspv > /tmp/uname || touch /tmp/uname
+       [ -r /proc/cmdline ] && cat /proc/cmdline > /tmp/cmdline || touch /tmp/cmdline
+       [ -r /proc/atags ] && cat /proc/atags > /tmp/atags || touch /tmp/atags
+       if [ -e $DEVCACHE ] && \
+          cmp -s /tmp/uname /etc/udev/saved.uname && \
+          cmp -s /tmp/cmdline /etc/udev/saved.cmdline && \
+          cmp -s /tmp/atags /etc/udev/saved.atags; then
+               (cd /; tar xf $DEVCACHE > /dev/null 2>&1)
+               not_first_boot=1
+       fi
+fi
+
+if [ ! -e "/lib/modules/$(uname -r)"/modules.dep ] ; then
+       mkdir -p /lib/modules/$(uname -r)
+       depmod -ae
+fi
+
+# make_extra_nodes
+kill_udevd > "/dev/null" 2>&1
+
+        # trigger the sorted events
+        echo -e '\000\000\000\000' > /proc/sys/kernel/hotplug
+        $DAEMON -d
+
+        $UDEVADM control --env STARTUP=1
+               if [ "$not_first_boot" != "" ];then
+                       $UDEVADM trigger --subsystem-nomatch=tty --subsystem-nomatch=mem \
+                       --subsystem-nomatch=vc --subsystem-nomatch=vtconsole --subsystem-nomatch=misc \
+                       --subsystem-nomatch=dcon --subsystem-nomatch=pci_bus --subsystem-nomatch=graphics \
+                       --subsystem-nomatch=backlight --subsystem-nomatch=video4linux --subsystem-nomatch=platform
+                       ($UDEVADM settle --timeout=3; $UDEVADM control --env STARTUP=)&
+                       if [ "$DEVCACHE" != "" ]; then
+                               rm -f /tmp/uname
+                               rm -f /tmp/cmdline
+                               rm -f /tmp/atags
+                       fi
+               else
+                       $UDEVADM trigger
+                       $UDEVADM settle
+               fi
+
+exit 0